
% EXPERIMENT 2: find and sketch over multiple scales

% TESTING IMAGE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%(scale hand-chosen, but tolerant to inaccuracy)

totalScale = 10;  % total number of scales
Sx1 = zeros(1, totalScale); Sy1 = zeros(1, totalScale); 
for(i=1:totalScale)
    J{i} = imresize_old(double(rgb2gray(imread('bikefind.jpg'))), .80+(i-1)*.05);  % scaled images
    [sx1, sy1] = size(J{i}); 
    Sx1(i) = sx1; Sy1(i) = sy1; % sizes of images
    tss1{i} = zeros(sx1, sy1);  % log-likelihood score map for testing images
    sym1{i} = zeros(sx1, sy1);  % symbolic sketch on testing image
end
mscale = zeros(1, totalScale);  % log-likelihood score over scales
ax = floor(sx/2); ay = floor(sy/2); % half size of bounding box


sub1 = 1; Lrange1 = 6; % we scan every pixel, Lrange*sub is fixed in learning and testing

% VARIABLES %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
allfiltered1 = applyfilter(J, allfilter, T);  % filter training images
allmaxed = applyfilter(J, allfilter, T);  % to be changed to local maximum


% MEX C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mex Cfind.c;   % compile C code
Cfind(totalScale, norient, allfiltered1, allmaxed, C, h, ax, ay, T, Mi, Mx, My, Mm, allsymbol(1, :), Lrange1, Orange, sub1, Totalsketch, Upperbound, tss1, sym1, Sx1, Sy1, mscale, LIK);

% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    


maxscale = max(mscale);   % most likely scale
for(i=1:totalScale)
    if(mscale(i)==maxscale)
       figure; 
       subplot(2, 2, 1, 'v6');  imshow(imread('bikefind.jpg'), []);   % original image
       subplot(2, 2, 2, 'v6');  imshow(J{i}+sym1{i}*100, []);  % overlaid sketch 
       subplot(2, 2, 3, 'v6');  plot(mscale);       % log-likelihood over scale      
       %subplot(2, 2, 4, 'v6');  imshow(-tss1{i}, []);  % log-likelihood score map
       subplot(2, 2, 4, 'v6');  mesh(tss1{i});  % log-likelihood score map
    end
end




